import java.util.Vector;

/*
 * Created on Jan 18, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author Yiqiao Wang
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Printer {
	public Vector allGoals = new Vector();
	public Vector pcVec = new Vector();
	public int loop =0;
	public int indentation=2;
	public void printXMIHeader() {
		System.out.println("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
		System.out.println("<org.eclipse.example.goalmodel:Goal xmi:version=\"2.0\"" +
				" xmlns:xmi=\"http://www.omg.org/XMI\"");	
	    //always create a NOP parent goal representing the entire program
		System.out.println("xmlns:org.eclipse.example.goalmodel=\"http:///org/eclipse/example/goalmodel.ecore\" name=\"NOP\">");
	}
	public void printXMIFooter() {
		System.out.println("</org.eclipse.example.goalmodel:Goal>");
	}
	
	public void printGoals(Vector goalVec) {
		
		int numGoals = goalVec.size();
		System.out.println("num goals are: " + numGoals);
		String name, cat, annot;
		Goal g;
		for (int i=0; i< numGoals; i++) {
			g = (Goal) goalVec.elementAt(i);
			name = g.getName();
			cat = g.getCat();
			annot = g.getAnnotation();
			int j=i+1;
			System.out.println("goal " + j + " has name: " + name + " category: " + cat);
			System.out.println("annotation: " + annot);			
		}
	}
	
	public void printXMI (Vector goalVec, Vector pcVec) {
		
		printXMIHeader();
		
		/*print XMI body
		 only print a goal's annotation if it is not null. 
		 only print a gola's category if it is OR
		 need to get pcVec from parser to find parent hierarchy. 
		*/
		printXMIBody(goalVec, pcVec);
		printXMIFooter();
	}
	
	public void printXMIBody(Vector goalVec, Vector pVec) {
		allGoals = goalVec;
		pcVec = pVec;
		Vector subGoalIDs, oneVec; 
		if (pcVec.size()> 0) {
			oneVec = (Vector) pcVec.elementAt(0);
			//prints root goal and all its children
			printGoal(oneVec, 1);
		}
	}
	
	//recursive, saves one vector from pcvec
	//contains the information of one parent goal and its children
	public void printGoal (Vector oneVec, int depth) {
	
		String name, cat, annot;
		boolean leafNode;
		Goal aGoal = new Goal();
		Vector tempVec;
		
		//empty space indented in front of each level of the goal
		
		int childId=0;
		
		Vector children = (Vector) oneVec.elementAt(2);
		int goalId = ((Integer) oneVec.elementAt(0)).intValue();
		//will not print for dummy root goal which is already printed in XMIHeader
		
		
		Goal parentGoal = new Goal();
		if (goalId != 0) {	
			parentGoal = aGoal.findGoal(goalId, allGoals);
			//Goal subGoal;
			name = parentGoal.getName();
			cat = parentGoal.getCat();
			annot = parentGoal.getAnnotation();
			int k= depth *indentation;
			for (int i=0; i < k; i++)
				System.out.print(" ");
			System.out.print("<subGoal name=\"" + name + "\"");
			if (annot.length()>0) 
				System.out.print(" annotation = \"" + annot + " \"");
			//print category only if it is OR
			if (cat.equals("OR")) 
				System.out.print(" category = OR");
			System.out.println(">");
		}//of if
		
	
		
		for (int i=0; i< children.size(); i++) {
			childId = ((Integer) children.elementAt(i)).intValue();
			//System.out.println("looking for level for node: " + childId);
			
			depth = findDepth (childId);
			//System.out.println("goal " + childId + " is at level: " + level);
			leafNode = isLeafNode (childId);
			if (leafNode) {
				printLeafNode (childId, depth);
			}
			else {	
				//print this child which is a parent. find its parentVec in pcVec
				tempVec = findVecInPcVec(childId);
				printGoal(tempVec, depth);
				
			}
		}
		if (goalId != 0) {	
			depth--;
			int k= depth *indentation;
			for (int i=0; i < k; i++)
				System.out.print(" ");
			System.out.println("</subGoal>");	
		}
	}
	//find which level a node is on for printing purpose
	public int findDepth (int id) {
		int depth=1;
		//if parentId =0, find its root, calculate how deep does it take to find the root
		Goal parent;
		Goal g = new Goal();
		Goal goal = g.findGoal(id, allGoals);
		int parentId = goal.parentId;
		while (parentId !=0) {
			depth++;
			parent = g.findGoal(parentId, allGoals);
			parentId = parent.parentId;
		}
		return depth;
	}
	public void printLeafNode (int childId, int depth) {
		
		Goal aGoal = new Goal();
		Goal g = aGoal.findGoal(childId, allGoals);
		String name, cat, annot;
		name = g.getName();
		cat = g.getCat();
		annot = g.getAnnotation();
		int temp = depth * indentation;
		for (int i=0; i< temp ; i++) 
			System.out.print(" ");
		System.out.print("<subGoal name=\"" + name + "\"");
		if (annot.length()>0) 
			System.out.print(" annotation = \"" + annot + " \"");
		//print category only if it is OR
		if (cat.equals("OR")) 
			System.out.print(" category = OR");
		System.out.println("/>");
		
	}
	
	public Vector findVecInPcVec(int childId) {
		int id;
		Vector tempVec;
		for (int i=0; i< pcVec.size(); i++) {
			tempVec = (Vector) pcVec.elementAt(i);
			id = ((Integer) tempVec.elementAt(0)).intValue();
			if (id == childId) 
				return tempVec;
		}
		System.out.println("error, parent not found in pcVec");
		System.exit(0);
		return new Vector();
		
	}
	public boolean isLeafNode (int childId) {
		int id;
		Vector tempVec;
		for (int i =0; i< pcVec.size(); i++) {
			tempVec = (Vector) pcVec.elementAt(i);
			id = ((Integer) tempVec.elementAt(0)).intValue();
			if (id == childId)
				return false;
		}
		return true;
	}
}
